/**
# mod_jvslidepro - JV Slide Pro
# @versions: 1.5.x,1.6.x,1.7.x,2.5.x
# ------------------------------------------------------------------------
# author    Open Source Code Solutions Co
# copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
# Websites: http://www.joomlavi.com
# Technical Support:  http://www.joomlavi.com/my-tickets.html
-------------------------------------------------------------------------*/

var JVWait = (function($){
    var waitgif = function(_selector,_options){
    var 
        options = $.extend({},waitgif.options,_options),
        selector = $(_selector),
        selectorPosition,
        This = this, 
        gif = $('<div>'),
        panel = $('<div>').addClass('jvwait').append(gif),
        modal = $('<div>').addClass('jvwait-overlay').mousedown(function(){return false}),
        picIndex,
        timeOut,
        start = function(){
            picIndex = options.srartIndex
            nextPic();
        },
        nextPic = function(){
            clearTimeout(timeOut);
            var bgPos = options.picSize * (picIndex ++);
            if(bgPos >= 480 ){
                picIndex = 0;
                bgPos = 0;
            } 
            gif.css('top', -bgPos);
            timeOut = setTimeout(function(){
                nextPic();
            },70)
        }
    ;
    modal.css('opacity',options.opacityModal);
    options.fixed || panel.css('position','absolute');
    $.extend(this,{
        show: function(){
            selectorPosition = selector.css('position');
            if(selectorPosition == 'inherit' || selectorPosition == 'static'){
                selector.css('position','relative');
            }
            start();
            selector.append(panel);            
            if(options.modal){
                modal.show();
                selector.append(modal)
            }
            panel.show().css('opacity',0).animate({opacity:1},{
                duration: options.duration
            });
        },
        hide: function(){
            panel.animate(
                {opacity:0},{
                    duration: options.duration,
                    complete: function(){
                        selector.css('position',selectorPosition);
                        panel.remove();
                        modal.hide().remove();
                        clearTimeout(timeOut);
                    }
                }
            );
        },
        modal: modal,
        gif: panel
    });
}
waitgif.options = {
    modal: true,
    duration: 300,
    opacityModal: 0.7,
    picSize: 40,
    srartIndex: 0,
    fixed: true
}
return waitgif;
})(jQuery);